# Announce: Rakudo Star Release 2014.09

## A useful, usable, "early adopter" distribution of Perl 6

On behalf of the Rakudo and Perl 6 development teams, I'm happy to
announce the September 2014 release of "Rakudo Star", a useful and usable
distribution of Perl 6. The tarball for the September 2014 release is
available from <http://rakudo.org/downloads/star/>.
Windows .MSI versions of Rakudo star for the MoarVM and Parrot backend
are also avaiable in the downloads area.

This Rakudo Star release comes with support for the MoarVM
backend (all module tests pass on supported platforms) along with
experimental support for the JVM backend (some module tests fail).
Two shipped modules are known to fail on Parrot (JSON::RPC and p6doc).

In the Perl 6 world, we make a distinction between the language
("Perl 6") and specific implementations of the language such as
"Rakudo Perl". This Star release includes [release 2014.09] of the
[Rakudo Perl 6 compiler], version 6.7.0 of the [Parrot Virtual
Machine], version 2014.09 of [MoarVM], plus various modules,
documentation, and other resources collected from the Perl 6
community.

[release 2014.09]:
    https://github.com/rakudo/rakudo/blob/nom/docs/announce/2014.09.md
[Rakudo Perl 6 compiler]: http://github.com/rakudo/rakudo
[Parrot Virtual Machine]: http://parrot.org
[MoarVM]: http://moarvm.org/

Some of the new features added to this release include:

* panda (the module installer client) does work on windows again
* panda knows about all modules, that are shipped with this release
* ./perl6 --profile for MoarVM
* Workaround OS X make bug for MoarVM
* support for submethod DESTROY (MoarVM only)
* optimizations to Str.words, Str.lines, IO.lines, chomp, and return
* added experimental support for Proc::Async, MoarVM only for now
* Reduced memory size of CORE.setting, improved startup time
* startup (on Moar) 15% faster than p5 w/ Moose

There are some key features of Perl 6 that Rakudo Star does not yet
handle appropriately, although they will appear in upcoming releases.
Some of the not-quite-there features include:

  * advanced macros
  * threads and concurrency (in progress for the JVM and MoarVM backend)
  * Unicode strings at levels other than codepoints
  * interactive readline that understands Unicode
  * non-blocking I/O
  * much of Synopsis 9 and 11

There is an online resource at <http://perl6.org/compilers/features>
that lists the known implemented and missing features of Rakudo and
other Perl 6 implementations.

In many places we've tried to make Rakudo smart enough to inform the
programmer that a given feature isn't implemented, but there are many
that we've missed. Bug reports about missing and broken features are
welcomed at <rakudobug@perl.org>.

See <http://perl6.org/> for links to much more information about
Perl 6, including documentation, example code, tutorials, reference
materials, specification documents, and other supporting resources. A
draft of a Perl 6 book is available as docs/UsingPerl6-draft.pdf in
the release tarball.

The development team thanks all of the contributors and sponsors for
making Rakudo Star possible. If you would like to contribute, see
<http://rakudo.org/how-to-help>, ask on the <perl6-compiler@perl.org>
mailing list, or join us on IRC \#perl6 on freenode.
