# Announce: Rakudo Star Release 2017.01

## A useful and usable production distribution of Perl 6

On behalf of the Rakudo and Perl 6 development teams, I'm pleased to
announce the November 2016 release of "Rakudo Star", a useful and usable
production distribution of Perl 6. The tarball for the January 2017 release
is available from <http://rakudo.org/downloads/star/>.

Binaries for macOS and Windows (64 bit) are also available.

This is the sixth post-Christmas (production) release of Rakudo Star and
implements Perl v6.c. It comes with support for the MoarVM backend (all module
tests pass on supported platforms).

This is the first Rakudo Star release to include "zef" as module installer.
"panda" is to be shortly replaced by "zef" and will be removed in the near
future.

It's hoped to produce quarterly Rakudo Star releases during 2017 with 2017.04
(April), 2017.07 (July) and 2017.10 (October) to follow.

Please note that this release of Rakudo Star is not fully functional with the
JVM backend from the Rakudo compiler. Please use the MoarVM backend only.

In the Perl 6 world, we make a distinction between the language ("Perl 6") and
specific implementations of the language such as "Rakudo Perl".

This Star release includes [release 2017.01] of the [Rakudo Perl 6 compiler],
version 2017.01 of [MoarVM], plus various modules, documentation, and other
resources collected from the Perl 6 community.

[release 2017.01]: https://raw.githubusercontent.com/rakudo/rakudo/2017.01/docs/announce/2017.01.md
[Rakudo Perl 6 compiler]: http://github.com/rakudo/rakudo
[MoarVM]: http://moarvm.org/

The Rakudo compiler changes since the last Rakudo Star release of 2016.11 are
now listed in "2016.12.md" and "2017.01.md" under the "rakudo/docs/announce"
directory of the source distribution.

Notable changes in modules shipped with Rakudo Star:

    + DBIish: Pg: TypeConverter post-merge cleanup
    + Linenoise: Remove dependency on Native::Resources
    + Pod-To-HTML: Bump version for #22 fix
    + Terminal-ANSIColor: Drop 'nqp' dependency
    + doc: Too many to list
    + json: Fix parsing of string literals with a leading combining character.
    + json\_fast: bump version since we now escape null bytes
    + panda: modified to warn of its removal in the short term
    + perl6-http-easy: Several pull requests merged
    + perl6-lwp-simple: Tweak tests to work with TAP::Harness
    + perl6-pod-to-bigpage: bump version
    + test-mock: Bump version.
    + zef: imported

There are some key features of Perl 6 that Rakudo Star does not yet
handle appropriately, although they will appear in upcoming releases.
Some of the not-quite-there features include:

  * advanced macros
  * non-blocking I/O (in progress)
  * some bits of Synopsis 9 and 11

There is an online resource at <http://perl6.org/compilers/features>
that lists the known implemented and missing features of Rakudo's
backends and other Perl 6 implementations.

In many places we've tried to make Rakudo smart enough to inform the
programmer that a given feature isn't implemented, but there are many
that we've missed. Bug reports about missing and broken features are
welcomed at <rakudobug@perl.org>.

See <http://perl6.org/> for links to much more information about
Perl 6, including documentation, example code, tutorials, presentations,
reference materials, design documents, and other supporting resources.
Some Perl 6 tutorials are available under the "docs" directory in
the release tarball.

The development team thanks all of the contributors and sponsors for
making Rakudo Star possible. If you would like to contribute, see
<http://rakudo.org/how-to-help>, ask on the <perl6-compiler@perl.org>
mailing list, or join us on IRC \#perl6 on freenode.
